/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/

#include <Application.h>

void IasEventHandler(uint32 event, void *eventParam)
{
    /* Alert Level Characteristic write event */
    if(event == CY_BLE_EVT_IASS_WRITE_CHAR_CMD)
    {
        /* Read the updated Alert Level value from the GATT database */
        Cy_BLE_IASS_GetCharacteristicValue(CY_BLE_IAS_ALERT_LEVEL, 
            sizeof(alertLevel), &alertLevel);
    }

    /* To remove unused parameter warning */
    eventParam = eventParam;
}

void immediate_alert(void)
{
    /* Update Alert Level value on the Blue LED */
    switch(alertLevel)
    {        
        case CY_BLE_NO_ALERT:
            /* Turn the Blue LED OFF in case of no alert */
            Cy_GPIO_Write(LED_PORT, LED_NUM, LED_OFF);
            break;

        /* Use the MCWDT to blink the Blue LED in case of mild alert */
        case CY_BLE_MILD_ALERT:
            /* The MCWDT interrupt handler will take care of LED blinking */
            break;

        case CY_BLE_HIGH_ALERT:
            /* Turn the Blue LED ON in case of high alert */
            Cy_GPIO_Write(LED_PORT, LED_NUM, LED_ON);
            break;
            
        /* Do nothing in all other cases */        
        default:
            break;
    }
}

/* [] END OF FILE */
