/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include <MC_WDT.h>

extern uint8 alertLevel;
uint16 MillisecondCounter;
extern uint16 displaydelay;

void MC_WDT_initialise(void)
{
    /* Enable 4 Hz free-running MCWDT counter 0*/
    /* MCWDT_config structure is defined by the MCWDT_PDL component based on
       parameters entered in the customizer */
    Cy_MCWDT_Init(MCWDT_Periodic_HW, &MCWDT_Periodic_config);
    /* Unmask the MCWDT counter 0 peripheral interrupt */
    Cy_MCWDT_SetInterruptMask(MCWDT_Periodic_HW, CY_MCWDT_CTR0);
    /* Enable MCWDT counter 0 */ 
    Cy_MCWDT_Enable(MCWDT_Periodic_HW, CY_MCWDT_CTR0, 93 /* 2 LFCLK cycles */);
    
    /* Configure ISR connected to MCWDT interrupt signal*/
    /* MCWDT_isr_cfg structure is defined by the SYSINT_PDL component based on
       parameters entered in the customizer. */
    Cy_SysInt_Init(&SysInt_Periodic_cfg, &MCWDT_Interrupt_Handler);
    /* Clear CM4 NVIC pending interrupt for MCWDT */
    NVIC_ClearPendingIRQ(SysInt_Periodic_cfg.intrSrc);
    /* Enable CM4 NVIC MCWDT interrupt */
    NVIC_EnableIRQ(SysInt_Periodic_cfg.intrSrc);
}

void MCWDT_Interrupt_Handler(void)
{
    /* Clear the MCWDT peripheral interrupt */
    Cy_MCWDT_ClearInterrupt(MCWDT_Periodic_HW, CY_MCWDT_CTR0);
    /* Clear the CM4 NVIC pending interrupt for MCWDT */
    NVIC_ClearPendingIRQ(SysInt_Periodic_cfg.intrSrc);
    
    if(alertLevel==CY_BLE_MILD_ALERT)
    {
        if(++MillisecondCounter>=1000)
        {
            Cy_GPIO_Inv(LED_PORT, LED_NUM);  
            
            MillisecondCounter=0;
        }
    }
    else
    {
        MillisecondCounter=0;
    }
    
    displaydelay++;
}

/* [] END OF FILE */
